
dim shared images(20, 39, 39) as integer

declare function initialiseImages as boolean
                           
declare sub dessineCarreau(byval iPiece   as integer,_
                           byval iCouleur as integer,_
                           byval iCarreau as integer,_
                           byval x0       as integer,_
                           byval y0       as integer)

declare sub dessineTablier(byval gauche   as integer,_
                           byval haut     as integer)
                           
function initialiseImages as boolean
  dim as integer i, j, k
  dim as integer ff = freefile
  dim as integer erreur = open("Pieces.txt" for input as #ff)
  dim s as string
  if erreur = 0 then
    for i = 0 to 20
      for j = 0 to 39
        line input #ff, s
        for k = 0 to 39
          images(i, j, k) = s[k] - 48
        next k
      next j
    next i
    return vrai
  else
    return faux
  end if
end function

sub dessineCarreau(byval iPiece   as integer,_
                   byval iCouleur as integer,_
                   byval iCarreau as integer,_
                   byval x0 as integer,_
                   byval y0 as integer)
  
  dim as integer x, y
  
  for y = 0 to 39
    for x = 0 to 39
      if images(iPiece + 7 * iCouleur, y, x) then
        pSet(x0 + x, y0 + y)
      else
        pReset(x0 + x, y0 + y)
      end if
      if iCarreau andalso images(iPiece + 14, y, x) then
        pSet(x0 + x, y0 + y)
      end if
    next x
  next y
  
end sub

sub dessineTablier(gauche as integer, haut as integer)
  '
  color chessBoardColor, chessBoardBkColor
  '
  dim as integer ligne, colonne
  dim as integer piece, couleur, carreau
  '
  for ligne =  0 to 7
    for colonne = 0 to 7
      piece = abs(courante.damier(colonne, 7 - ligne))
      if courante.damier(colonne, 7 - ligne) > 0 then couleur = 0 else couleur = 1
      carreau = (ligne + colonne) mod 2
      dessineCarreau(piece, couleur, carreau, gauche + 40 * colonne, haut + 40 * ligne)
    next colonne
  next ligne
  '
  exit sub
  '
  for n as integer = 0 to 7
    draw string (gauche - 016 - 08, haut + 12 + 40 * n), chr(56 - n)
    draw string (gauche + 320 + 16, haut + 12 + 40 * n), chr(56 - n)
    draw string (gauche + 016 + 40 * n, haut - 012 - 16), chr(97 + n)
    draw string (gauche + 016 + 40 * n, haut + 320 + 12), chr(97 + n)
  next n
end sub
